'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function (log) {
  var defaultOptions = {
    endOfLineChar: _os2.default.EOL
  };
  // Determine the default location of the config and log files.
  if (/^win/.test(_os2.default.platform())) {
    log.main('Windows platform detected.');
    var programFiles = 'Program Files';
    if (/64/.test(_os2.default.arch())) {
      programFiles += ' (x86)';
    }
    defaultOptions.logFile = _path2.default.join('C:', programFiles, 'Hearthstone', 'Hearthstone_Data', 'output_log.txt');
    defaultOptions.configFile = _path2.default.join(process.env.LOCALAPPDATA, 'Blizzard', 'Hearthstone', 'log.config');
  } else {
    log.main('OS X platform detected.');
    defaultOptions.logFile = _path2.default.join(process.env.HOME, 'Library', 'Logs', 'Unity', 'Player.log');
    defaultOptions.configFile = _path2.default.join(process.env.HOME, 'Library', 'Preferences', 'Blizzard', 'Hearthstone', 'log.config');
  }

  return defaultOptions;
};

var _os = require('os');

var _os2 = _interopRequireDefault(_os);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }